#include<iostream>
#include<vector>
#include<string>
#define MOD 1000000007
#define ALPHABET_SIZE 26
using namespace std;



inline int mmult(int a, int b) {
	return (1LL * a * b) % MOD;
}

inline int madd(int a, int b) {
	return (a + b) % MOD;
}

inline int msub(int a, int b) {
	return (0LL + a + MOD - b) % MOD;
}



int n, m, spow[100001], bhash, acchash;

//find occourence of b in a
string a, b;



//--------------------------------------------------------------------
//Main function begins here


int main() {
	cin.sync_with_stdio(false);
	
	cin >> n >> m >> a >> b;
	
	
	
	spow[0] = 1;
	
	for(int i=1;i<=100000;i++)
		spow[i] = mmult(spow[i-1], ALPHABET_SIZE);
		
		
	for(int i=0;i<m;i++) {
		bhash = madd(mmult(bhash, ALPHABET_SIZE),  b[i] - 'a');
		
		acchash = madd(mmult(acchash, ALPHABET_SIZE), a[i] - 'a');
	}
	
	
	
	
	for(int i=0;i+m <= n;i++) {
		
		
		//check hash matching
		if(acchash == bhash) {
			
			bool matches = true;
			
			for(int j=0;j<m;j++)
				if(a[i+j] != b[j])
					matches = false;
					
			
			if(matches) {
				cout << "jah\n";
				return 0;
			}
			
		}
		
		
		acchash = msub(mmult(acchash, ALPHABET_SIZE), mmult(a[i] - 'a', spow[m]) );
		
		if(i+m < n)
			acchash = madd(acchash, a[i+m] - 'a');
		
	}
	
	
	cout << "ei\n";
	return 0;
}
































